`timescale 1 ps / 1ps

module tst_top ; 

reg wr_clk, rd_clk, toggle ;
reg [15:0] datain ;
wire [7:0] dataout ;
reg [7:0] dataout_buf ;
reg [15:0] dataout_word ;
reg [15:0] dataout_word_buf ;
reg rst, match ;
reg we ;
wire oe ;
wire [2:0] flag ;
reg [3:0] count ;

assign oe = flag[1] ;

always @(posedge wr_clk or posedge rst)
begin
if (rst) begin
	datain <= 16'h0000 ;
	count <= 4'b0000 ;
	we <= 1'b0 ;
end
else begin
	count <= count + 4'b0001 ;
	if (count == 4'b1111) begin
		we <= ~we ;
	end
	if (we) begin
		datain <= datain + 1 ;
	end
end
end

always @(posedge rd_clk or posedge rst)
begin
if (rst) begin
	match <= 1'b0 ;
	toggle <= 1'b0 ;
	dataout_buf <= 8'h00 ;
	dataout_word <= 16'h0000 ;
	dataout_word_buf <= 16'h0000 ;
end
else begin
	if (oe) begin
		toggle <= ~toggle ;
		dataout_buf <= dataout ;
		if (toggle) begin
			dataout_word <= {dataout_buf, dataout} ;
			dataout_word_buf <= dataout_word ;
			if (dataout_word == dataout_word_buf + 1) begin
				match <= 1'b1 ;
			end else begin
				match <= 1'b0 ;
			end
		end
	end
end
end

initial rd_clk = 0 ;
initial wr_clk = 0 ;

always #(7000) rd_clk = ~rd_clk ;
always #(16000) wr_clk = ~wr_clk  ;

saf_2to1 chip (
	.wr_clk(wr_clk),
	.rd_clk(rd_clk),
	.datain(datain),
	.rst(rst),
	.we(we),
	.oe(oe),
	.flag(flag),
	.dataout(dataout)); 

initial
begin
rst = 1'b1 ;

#20000
rst = 1'b0 ;

//$stop ;
end 

endmodule
