library ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all ;

ENTITY tst_top IS END tst_top;

ARCHITECTURE rtl OF tst_top IS
component saf_1to1  PORT (
	wr_clk 	: in std_logic;
	rd_clk 	: in std_logic;
	datain 	: in std_logic_vector(15 downto 0);
	rst 	: in std_logic;
	we 	: in std_logic;
	oe	: in std_logic ;
	flag	: out std_logic_vector(2 downto 0) ;
	dataout	: out std_logic_vector(15 downto 0)); 
END component;

SIGNAL wr_clk, rd_clk : std_logic := '1' ;
SIGNAL datain : std_logic_vector(15 downto 0) := "1111111111111111" ;
signal dataout, dataout_buf : std_logic_vector(15 downto 0) ;
signal rst : std_logic := '1' ;
signal we, match : std_logic := '0';
signal oe : std_logic := '0';
signal flag : std_logic_vector(2 downto 0) ;
signal count : std_logic_vector(3 downto 0) ;

BEGIN

rd_clk <= not rd_clk after 7 ns ;
wr_clk <= not wr_clk after 8 nS ;
rst <= '0' after 10 nS;
oe <= flag(1) ;

process (wr_clk, rst)
begin
if rst = '1' then
	count <= (others => '0') ;
elsif wr_clk'event and wr_clk = '1' then
	count <= count + 1 ;
	if count = "1111" then
		we <= not we ;
	end if ;
	if we = '1' then 
		datain <= datain + 1 ;
	end if ;
end if ;
end process ;

process (rd_clk, rst)
begin
if rst = '1' then
	match <= '0' ;
	dataout_buf <= (others => '0') ;
elsif rd_clk'event and rd_clk = '1' then
	if oe = '1' then
		dataout_buf <= dataout ;
		if dataout = dataout_buf + 1 then
			match <= '1' ;
		else
			match <= '0' ;
		end if ;
	end if ;
end if ;
end process ;

chip : saf_1to1 port map (
	wr_clk 	=> wr_clk,
	rd_clk 	=> rd_clk,
	datain 	=> datain,
	rst 	=> rst,
	we 	=> we,
	oe	=> oe,
	flag	=> flag,
	dataout	=> dataout); 

END rtl;
